# SoTexture2 Class Reference
[Nodes]

`#include <Inventor/nodes/SoTexture2.h>`

Inheritance diagram for SoTexture2:

List of all members.

## Detailed Description

The SoTexture2 class is used to map a 2D texture onto subsequent geometry in the scenegraph.

Shape nodes within the scope of SoTexture2 nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTexture2) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied.

For a simple usage example, see the class documentation for SoSFImage.

When working with Inventor files, one often wants to embed external texture image files into the Inventor files themselves. Here's a minimal, stand-alone example which shows how that can be accomplished by calling SoField::touch() on the SoTexture2::image fields before scenegraph export:

      #include <Inventor/SoDB.h>
      #include <Inventor/nodes/SoSeparator.h>
      #include <Inventor/nodes/SoTexture2.h>
      #include <Inventor/actions/SoSearchAction.h>
      #include <Inventor/actions/SoWriteAction.h>

      int
      main(void)
      {
        SoDB::init();

        SoInput in;
        SoSeparator * root = SoDB::readAll(&in);
        if (!root) { exit(1); }

        root->ref();

        SoSearchAction searchaction;
        searchaction.setType(SoTexture2::getClassTypeId());
        searchaction.setSearchingAll(TRUE);
        searchaction.setInterest(SoSearchAction::ALL);

        searchaction.apply(root);

        const SoPathList & pl = searchaction.getPaths();
        for (int i=0; i < pl.getLength(); i++) {
          SoFullPath * fp = (SoFullPath *)pl[i];
          SoTexture2 * tex = (SoTexture2 *)fp->getTail();
          assert(tex->getTypeId() == SoTexture2::getClassTypeId());
          tex->image.touch();
        }

        SoWriteAction wa;
        wa.apply(root);

        root->unref();

        return 0;
      }

Run the example by piping the iv-file you want do texture-embedding on from stdin, e.g. like this:

      $ ./test < input.iv

## Public Types

enum | Model { MODULATE = SoTextureImageElement::MODULATE, DECAL = SoTextureImageElement::DECAL, BLEND = SoTextureImageElement::BLEND }
enum | Wrap { REPEAT = SoTextureImageElement::REPEAT, CLAMP = SoTextureImageElement::CLAMP }

## Public Member Functions

| SoTexture2 (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)

## Static Public Member Functions

void | initClass (void)
SbBool | readImage (const SbString &fname, int &w, int &h, int &nc, unsigned char *&bytes)

## Public Attributes

SoSFString | filename
SoSFImage | image
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor

## Protected Member Functions

virtual | ~SoTexture2 ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)

## Member Enumeration Documentation

enum SoTexture2::Model

Texture mapping model, for deciding how to "merge" the texturemap with the object it is mapped unto.

Enumeration values:

  MODULATE | Texture image is modulated with polygon shading.
  DECAL | Texture image overwrites polygon colors.
  BLEND | Blend texturemap image on polygons using the color stored in the SoTexture2::blendColor field.

enum SoTexture2::Wrap

Enumeration of wrapping strategies which can be used when the texturemap doesn't cover the full extent of the geometry.

Enumeration values:

  REPEAT | Repeat texture when coordinate is not between 0 and 1.
  CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

SoTexture2::SoTexture2 | ( | void |  | ) |

| Constructor.

SoTexture2::~SoTexture2 | ( |  | ) | `[protected, virtual]`

| Destructor. Frees up internal resources used to store texture image data.

## Member Function Documentation

void SoTexture2::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoTexture2::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoTexture2::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoTexture2::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoTexture2::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Action method for SoRayPickAction. Checks the ray specification of the action and tests for intersection with the data of the node. Nodes influencing relevant state variables for how picking is done also overrides this method. Reimplemented from SoNode.

SbBool SoTexture2::readImage | ( | const SbString & | fname,
|  | int & | w,
|  | int & | h,
|  | int & | nc,
|  | unsigned char *& | bytes
| ) | `[static]`

| Not implemented in Coin; should probably not have been public in the original SGI Open Inventor API. We'll consider to implement it if requested.

SbBool SoTexture2::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoTexture2::notify | ( | SoNotList * | l | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode.

int SoTexture2::getReadStatus | ( | void |  | ) | `[protected]`

| Returns read status. 1 for success, 0 for failure.

void SoTexture2::setReadStatus | ( | int | s | ) | `[protected]`

Sets read status.

See also:
  getReadStatus()

## Member Data Documentation

SoSFString SoTexture2::filename

Texture filename, referring to a file on disk in a supported image bitmap format.

By default contains an empty string, which means the texture will be fetched from SoTexture2::image and not from disk. (Specify either this field or use SoTexture2::image, not both.)

For reading texture image files from disk, Coin uses the "simage" library from Systems in Motion. This library must be installed for it to be possible to load any image files at all.

The set of image formats you can actually read with the simage library depends on how the simage library was built, as simage is again dependent on a few other low-level file import/export libraries (for instance for JPEG, GIF, TIFF and PNG support). To make sure all wanted formats are supported, you should build the simage library yourself.

The set of image formats guaranteed to be supported by simage is Targa (.tga), PIC (.pic), SGI RGB (.rgb, .bw) and XWD (.xwd).

For more information about the simage library, including download and build instructions, see the Coin www-pages.

SoSFImage SoTexture2::image

| Inline image data. Defaults to contain an empty image. See documentation of the SoSFImage class for a very detailed description of how the format specification for the image data is layed out, and what different image formats for color textures, semi-transparent textures, grayscale textures, etc etc, are supported.

SoSFEnum SoTexture2::wrapS

| Wrapping strategy for the S coordinate when the texturemap is narrower than the object to map unto. Default value is SoTexture2::REPEAT.

SoSFEnum SoTexture2::wrapT

| Wrapping strategy for the T coordinate when the texturemap is shorter than the object to map unto. Default value is SoTexture2::REPEAT.

SoSFEnum SoTexture2::model

| Texturemapping model for how the texturemap is "merged" with the polygon primitives it is applied to. Default value is SoTexture2::MODULATE.

SoSFColor SoTexture2::blendColor

| Blend color. Used when SoTexture2::model is SoTexture2::BLEND. Default color value is [0, 0, 0], black, which means no contribution to the blending is made.

The documentation for this class was generated from the following files:

- SoTexture2.h
- SoTexture2.cpp